# Creation rapide dark theme 

![tag](javascript)
![tag](css)
![category](web)

Si vous avez un site web classique avec un thème lumineux (fond blanc) il peut etre simple de créer un theme sombre.
Il suffit en effet d'utiliser cette élèment web

```css
body.dark {
    filter: invert(90%);
}
```

il suffit donc d'ajouter une classe **dark** à la balise body.

Pour cela il est possible d'ajouter un lien "dark theme" en javascript et de faire en sorte lors de l'appui sur ce lien de l'ajout (ou la suppression) de la classe dark à la balise body.

Pour enregistrer l'usage du theme il est aussi possible d'utiliser un cookie.

Exemple de fichier javascript

```javascript
function setCookie(cname, cvalue, exdays) {
    const d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    let expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

function getCookie(cname) {
    let name = cname + "=";
    let ca = document.cookie.split(';');
    for(let i = 0; i < ca.length; i++) {
        let c = ca[i];
        while (c.charAt(0) == ' ') {
        c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
        return c.substring(name.length, c.length);
        }
    }
    return "";
}

function getCookieName() {
    return "mycookie";
}

function clickdarkmode() {
    if (document.body.classList.contains('dark')) {
        document.body.classList.remove('dark');
        setCookie(getCookieName(), "off", 30);
        console.log("dark mode off");
    } else {
        document.body.classList.add('dark');
        setCookie(getCookieName(), "on", 30);
        console.log("dark mode on");
    }
    return false;
}

$(document).ready(function() {
    console.log("dark.js");
    var topmenu = document.getElementById("top-menu");
    var divdark = document.createElement("div");
    divdark.id = "dark";
    var adivdark = document.createElement("a");
    adivdark.innerText = "dark mode";
    adivdark.href = "";
    divdark.appendChild(adivdark);
    topmenu.insertBefore(divdark, topmenu.firstChild)
    adivdark.onclick = clickdarkmode;
    let initdark = getCookie(getCookieName());
    if (initdark == "on") {
        clickdarkmode();
    }
});
 


```